# Summary

[🗈 Stavros' notes](welcome/stavros-notes.md)
- [🛸 Drone stuff](drone-stuff/index.md)
    - [🗈 A simple guide to PID control](drone-stuff/a-simple-guide-to-pid-control.md)
    - [🗈 E6000 hinges](drone-stuff/e6000-hinges.md)
    - [🗈 Fixing the Matek ELRS receivers](drone-stuff/fixing-the-matek-elrs-receivers.md)
    - [🗈 FPV frequency chart](drone-stuff/fpv-frequency-chart.md)
    - [🗈 Getting uninverted SBUS on a no-name FrSky-compatible receiver](drone-stuff/getting-uninverted-sbus-on-a-no-name-frsky-compatible-receiver.md)
    - [🗈 Getting uninverted SBUS/SmartPort on the FrSky XSR receiver](drone-stuff/getting-uninverted-sbus-smartport-on-the-frsky-xsr-receiver.md)
    - [🗈 INAV tuning tips](drone-stuff/inav-tuning-tips.md)
    - [🗈 Miscellaneous](drone-stuff/miscellaneous.md)
    - [🗈 Omnibus F4 pro servo diode](drone-stuff/omnibus-f4-pro-servo-diode.md)
    - [🗈 Omnibus F4 V3 pinout](drone-stuff/omnibus-f4-v3-pinout.md)
    - [🗈 QGroundControl to Mission Planner conversion script](drone-stuff/qgroundcontrol-to-mission-planner-conversion-script.md)
    - [🗈 Transmitter external module pinout](drone-stuff/transmitter-external-module-pinout.md)
    - [🗈 Transportable C1 Chaser](drone-stuff/transportable-c1-chaser.md)
    - [🛩️ ArduPilot](ardupilot/index.md)
        - [🗈 ArduPilot recommended settings](ardupilot/ardupilot-recommended-settings.md)
        - [🗈 ArduPilot setup checklist](ardupilot/ardupilot-setup-checklist.md)
        - [🗈 Bitmask calculator](ardupilot/bitmask-calculator.md)
        - [🗈 Building ArduPilot](ardupilot/building-ardupilot.md)
        - [🗈 Configuring a switch as a relay](ardupilot/configuring-a-switch-as-a-relay.md)
        - [🗈 Current sensor calibrator](ardupilot/current-sensor-calibrator.md)
        - [🗈 DJI FPV configuration](ardupilot/dji-fpv-configuration.md)
        - [🗈 ELRS preferred configuration](ardupilot/elrs-preferred-configuration.md)
        - [🗈 HD OSD tool](ardupilot/hd-osd-tool.md)
        - [🗈 Installing WTFOS on DJI](ardupilot/installing-wtfos-on-dji.md)
        - [🗈 Miscellaneous notes](ardupilot/miscellaneous-notes.md)
        - [🗈 Reverse thrust](ardupilot/reverse-thrust.md)
        - [🗈 Statistics calculator](ardupilot/statistics-calculator.md)
        - [🗈 TECS tuning calculator](ardupilot/tecs-tuning-calculator.md)
        - [🗈 Transfer config between craft](ardupilot/transfer-config-between-craft.md)
        - [🗈 Tuning the TECS](ardupilot/tuning-the-tecs.md)
    - [🏗️ Model build notes](model-build-notes/index.md)
        - [🗈 Build notes for the FT Mighty Mini Arrow](model-build-notes/build-notes-for-the-ft-mighty-mini-arrow.md)
        - [🗈 Mini Drak build condensed instructions](model-build-notes/mini-drak-build-condensed-instructions.md)
- [📁 Maker things](maker-things/index.md)
    - [🗈 Battery discharge curves](maker-things/battery-discharge-curves.md)
    - [🗈 Electronics tips](maker-things/electronics-tips.md)
    - [🗈 GRBL_ESP32 tips](maker-things/grbl-esp32-tips.md)
    - [🗈 How to properly level your 3D printer](maker-things/how-to-properly-level-your-3d-printer.md)
    - [🗈 Info on various hardware components](maker-things/info-on-various-hardware-components.md)
    - [🗈 Installing BLTouch-compatible firmware onto the TwoTrees Sapphire Pro](maker-things/installing-bltouch-compatible-firmware-onto-the-twotrees-sapphire-pro.md)
    - [🗈 Notes on my TimSav](maker-things/notes-on-my-timsav.md)
- [🖥️ Programming](programming/index.md)
    - [🗈 Interesting projects](programming/interesting-projects.md)
    - [🐍 Python](python/index.md)
        - [🗈 Decorator that runs a function in a thread](python/decorator-that-runs-a-function-in-a-thread.md)
- [💽 Software](software/index.md)
    - [🗈 Black pills](software/black-pills.md)
    - [🗈 Getting VoWiFi working on Xiaomi.eu](software/getting-vowifi-working-on-xiaomi-eu.md)
    - [🗈 Monero GUI syncing stuck with Ledger](software/monero-gui-syncing-stuck-with-ledger.md)
    - [🗈 Pairing the Xbox One controller in Linux](software/pairing-the-xbox-one-controller-in-linux.md)
    - [🗈 Resetting TP-Link Powerline plugs](software/resetting-tp-link-powerline-plugs.md)
    - [🗈 Test and format SD cards](software/test-and-format-sd-cards.md)